import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A collection of pieces that can switch locations when clicked. The getClicked() method is in the
 * myActor class.
 */
public class SlidingPiece  extends myActor
{
    static GreenfootImage[] piece = new GreenfootImage[22]; //Static to reduce load times.
    int slider_piece; //The ID number of this piece.

    public SlidingPiece(int piece_num)
    {
        slider_piece = piece_num; //Assign the piece ID to the number we were given.

        /**
         * Load the images.
         */
        if(piece[1] == null) //Only load up the images once. This improves gameplay and reduces load times.
        {
            /**
             * You can replace the .png files with your own to make your own sliding puzzle.
             */
            piece[1] = new GreenfootImage("2.png");
            piece[2] = new GreenfootImage("3.png");
            piece[3] = new GreenfootImage("4.png");
            piece[4] = new GreenfootImage("1.png");

            piece[5] = new GreenfootImage("2-1.png");
            piece[6] = new GreenfootImage("2-2.png");
            piece[7] = new GreenfootImage("2-3.png");
            piece[8] = new GreenfootImage("2-4.png");

            piece[9] = new GreenfootImage("3-1.png");
            piece[10] = new GreenfootImage("3-2.png");
            piece[11] = new GreenfootImage("3-3.png");
            piece[12] = new GreenfootImage("3-4.png");

            piece[13] = new GreenfootImage("4-1.png");
            piece[14] = new GreenfootImage("4-2.png");
            piece[15] = new GreenfootImage("4-3.png");
            piece[16] = new GreenfootImage("4-4.png");

            piece[17] = new GreenfootImage("1-1.png");
            piece[18] = new GreenfootImage("1-2.png");
            piece[19] = new GreenfootImage("1-3.png");
            piece[20] = new GreenfootImage("1-4.png");
        }

        for(int i = 1; i < 5; i++) //Run through numbers 1-4.
        {
            piece[i].scale(200, 200); //Scale the images to the correct size for the default board.
        }

        for(int i = 5; i < 21; i++)
        {
            piece[i].scale(100, 100); //Scale the images to the correct size for the default board.
        }

        setImage(piece[slider_piece]); //Use the image that corresponds with the ID.
    }

    /**
     * Act - This is called whenever the "Act" or "Run" button is pressed in the environment.
     */

    public void act() 
    {
        /**
         * If we're in shuffle mode, shuffle click (Automatic click) else, use user input.
         */
        if(((myWorld) getWorld()).shuffle)
        {
            getClicked(true); // In the "myActor" class
        }
        else
        {
            getClicked(); // Find this in the class "myActor"
            getArrowed();
        }
    }
}
