import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Just a simple code that contains the getClicked() method the SlidingPieces use to get clicked.
 */
public class myActor  extends Actor
{
    int s_x, s_y;
    int offset;

    public void getClicked()
    {
        /**
         * When the piece is clicked...
         */
        if(Greenfoot.mouseClicked(this))
        {
            /**
             * The image width offset.
             */
            offset = getImage().getWidth();

            /**
             * Assign the empty locations to a local variable.
             */
            s_x = ((myWorld) getWorld()).Empty_x;
            s_y = ((myWorld) getWorld()).Empty_y;

            /**
             * Move to the empty location on the board (Starts as 2, 2)
             * 
             * [Bugfix]
             * Make sure we aren't moving at a diagonal. Use Pythagorean Theorum to see if the distance
             * between the empty space and this spot is less or equal to the size of the image.
             * If it is, we can move.
             */
            double thisx = getX() - s_x;
            double thisy = getY() - s_y;
            double distance = Math.sqrt(thisx*thisx + thisy*thisy); // Returns distance here to there.

            if(distance <= offset)
            {
                /**
                 * Store the x and y coordinate before we move...
                 */
                ((myWorld) getWorld()).Stored_Empty_x = this.getX();
                ((myWorld) getWorld()).Stored_Empty_y = this.getY();

                /**
                 * Move.
                 */
                this.setLocation(((myWorld) getWorld()).Empty_x, ((myWorld) getWorld()).Empty_y);
            }
            else
            {
                /**
                 * Stop the loop if there has been an illegal click.
                 */
                return;
            }

            /**
             * Set the empty location to the previous location of the piece (The ints we stored before
             * we moved)
             */
            ((myWorld) getWorld()).Empty_x = ((myWorld) getWorld()).Stored_Empty_x;
            ((myWorld) getWorld()).Empty_y = ((myWorld) getWorld()).Stored_Empty_y;
        }
    }

    public void getClicked(boolean automatically)
    {
        /**
         * The image width offset.
         */
        offset = getImage().getWidth();

        /**
         * Assign the empty locations to a local variable.
         */
        s_x = ((myWorld) getWorld()).Empty_x;
        s_y = ((myWorld) getWorld()).Empty_y;

        /**
         * Move to the empty location on the board (Starts as 2, 2)
         * 
         * [Bugfix]
         * Make sure we aren't moving at a diagonal. Use Pythagorean Theorum to see if the distance
         * between the empty space and this spot is less or equal to the size of the image.
         * If it is, we can move.
         */
        double thisx = getX() - s_x;
        double thisy = getY() - s_y;
        double distance = Math.sqrt(thisx*thisx + thisy*thisy); // Returns distance here to there.

        if(distance <= offset)
        {
            /**
             * Store the x and y coordinate before we move...
             */
            ((myWorld) getWorld()).Stored_Empty_x = this.getX();
            ((myWorld) getWorld()).Stored_Empty_y = this.getY();

            /**
             * Move and wait 3 ticks.
             */
            this.setLocation(((myWorld) getWorld()).Empty_x, ((myWorld) getWorld()).Empty_y);
            Greenfoot.delay(3);
        }
        else
        {
            /**
             * If we can't move, don't go any further.
             */
            return;
        }

        /**
         * Set the empty location to the previous location of the piece (The ints we stored before
         * we moved)
         */
        ((myWorld) getWorld()).Empty_x = ((myWorld) getWorld()).Stored_Empty_x;
        ((myWorld) getWorld()).Empty_y = ((myWorld) getWorld()).Stored_Empty_y;

        ((myWorld) getWorld()).shuffle = true;
    }

    /**
     * Here starts arrow key movement. Essentially copied off of getClicked();
     */
    protected void getArrowed()
    {
            /**
             * Move left.
             */
            if(((myWorld) getWorld()).key == "left")
            {
                /**
                 * The image width offset.
                 */
                offset = getImage().getWidth();

                /**
                 * Assign the empty locations to a local variable.
                 */
                s_x = ((myWorld) getWorld()).Empty_x;
                s_y = ((myWorld) getWorld()).Empty_y;

                /**
                 * Move to the empty location on the board (Starts as 2, 2)
                 * 
                 * [Bugfix]
                 * Make sure we aren't moving at a diagonal. Use Pythagorean Theorum to see if the distance
                 * between the empty space and this spot is less or equal to the size of the image.
                 * If it is, we can move.
                 */
                double thisx = getX() - s_x;
                double thisy = getY() - s_y;
                double distance = Math.sqrt(thisx*thisx + thisy*thisy); // Returns distance here to there.

                if(distance <= offset && s_x < this.getX() && s_y == this.getY())
                {
                    /**
                     * Store the x and y coordinate before we move...
                     */
                    ((myWorld) getWorld()).Stored_Empty_x = this.getX();
                    ((myWorld) getWorld()).Stored_Empty_y = this.getY();

                    /**
                     * Move.
                     */
                    this.setLocation(((myWorld) getWorld()).Empty_x, ((myWorld) getWorld()).Empty_y);
                }
                else
                {
                    /**
                     * Stop the loop if there has been an illegal press.
                     */
                    return;
                }

                /**
                 * Set the empty location to the previous location of the piece (The ints we stored before
                 * we moved)
                 */
                ((myWorld) getWorld()).Empty_x = ((myWorld) getWorld()).Stored_Empty_x;
                ((myWorld) getWorld()).Empty_y = ((myWorld) getWorld()).Stored_Empty_y;
            }

            /**
             * Move right.
             */
            if(((myWorld) getWorld()).key == "right")
            {
                /**
                 * The image width offset.
                 */
                offset = getImage().getWidth();

                /**
                 * Assign the empty locations to a local variable.
                 */
                s_x = ((myWorld) getWorld()).Empty_x;
                s_y = ((myWorld) getWorld()).Empty_y;

                /**
                 * Move to the empty location on the board (Starts as 2, 2)
                 * 
                 * [Bugfix]
                 * Make sure we aren't moving at a diagonal. Use Pythagorean Theorum to see if the distance
                 * between the empty space and this spot is less or equal to the size of the image.
                 * If it is, we can move.
                 */
                double thisx = getX() - s_x;
                double thisy = getY() - s_y;
                double distance = Math.sqrt(thisx*thisx + thisy*thisy); // Returns distance here to there.

                if(distance <= offset && s_x > this.getX() && s_y == this.getY())
                {
                    /**
                     * Store the x and y coordinate before we move...
                     */
                    ((myWorld) getWorld()).Stored_Empty_x = this.getX();
                    ((myWorld) getWorld()).Stored_Empty_y = this.getY();

                    /**
                     * Move.
                     */
                    this.setLocation(((myWorld) getWorld()).Empty_x, ((myWorld) getWorld()).Empty_y);
                }
                else
                {
                    /**
                     * Stop the loop if there has been an illegal press.
                     */
                    return;
                }

                /**
                 * Set the empty location to the previous location of the piece (The ints we stored before
                 * we moved)
                 */
                ((myWorld) getWorld()).Empty_x = ((myWorld) getWorld()).Stored_Empty_x;
                ((myWorld) getWorld()).Empty_y = ((myWorld) getWorld()).Stored_Empty_y;
            }

            /**
             * Move down.
             */
            if(((myWorld) getWorld()).key == "down")
            {
                /**
                 * The image width offset.
                 */
                offset = getImage().getWidth();

                /**
                 * Assign the empty locations to a local variable.
                 */
                s_x = ((myWorld) getWorld()).Empty_x;
                s_y = ((myWorld) getWorld()).Empty_y;

                /**
                 * Move to the empty location on the board (Starts as 2, 2)
                 * 
                 * [Bugfix]
                 * Make sure we aren't moving at a diagonal. Use Pythagorean Theorum to see if the distance
                 * between the empty space and this spot is less or equal to the size of the image.
                 * If it is, we can move.
                 */
                double thisx = getX() - s_x;
                double thisy = getY() - s_y;
                double distance = Math.sqrt(thisx*thisx + thisy*thisy); // Returns distance here to there.

                if(distance <= offset && s_x == this.getX() && s_y > this.getY())
                {
                    /**
                     * Store the x and y coordinate before we move...
                     */
                    ((myWorld) getWorld()).Stored_Empty_x = this.getX();
                    ((myWorld) getWorld()).Stored_Empty_y = this.getY();

                    /**
                     * Move.
                     */
                    this.setLocation(((myWorld) getWorld()).Empty_x, ((myWorld) getWorld()).Empty_y);
                }
                else
                {
                    /**
                     * Stop the loop if there has been an illegal press.
                     */
                    return;
                }

                /**
                 * Set the empty location to the previous location of the piece (The ints we stored before
                 * we moved)
                 */
                ((myWorld) getWorld()).Empty_x = ((myWorld) getWorld()).Stored_Empty_x;
                ((myWorld) getWorld()).Empty_y = ((myWorld) getWorld()).Stored_Empty_y;
            }

            /**
             * Move up.
             */
            if(((myWorld) getWorld()).key == "up")
            {
                /**
                 * The image width offset.
                 */
                offset = getImage().getWidth();

                /**
                 * Assign the empty locations to a local variable.
                 */
                s_x = ((myWorld) getWorld()).Empty_x;
                s_y = ((myWorld) getWorld()).Empty_y;

                /**
                 * Move to the empty location on the board (Starts as 2, 2)
                 * 
                 * [Bugfix]
                 * Make sure we aren't moving at a diagonal. Use Pythagorean Theorum to see if the distance
                 * between the empty space and this spot is less or equal to the size of the image.
                 * If it is, we can move.
                 */
                double thisx = getX() - s_x;
                double thisy = getY() - s_y;
                double distance = Math.sqrt(thisx*thisx + thisy*thisy); // Returns distance here to there.

                if(distance <= offset && s_x == this.getX() && s_y < this.getY())
                {
                    /**
                     * Store the x and y coordinate before we move...
                     */
                    ((myWorld) getWorld()).Stored_Empty_x = this.getX();
                    ((myWorld) getWorld()).Stored_Empty_y = this.getY();

                    /**
                     * Move.
                     */
                    this.setLocation(((myWorld) getWorld()).Empty_x, ((myWorld) getWorld()).Empty_y);
                }
                else
                {
                    /**
                     * Stop the loop if there has been an illegal press.
                     */
                    return;
                }

                /**
                 * Set the empty location to the previous location of the piece (The ints we stored before
                 * we moved)
                 */
                ((myWorld) getWorld()).Empty_x = ((myWorld) getWorld()).Stored_Empty_x;
                ((myWorld) getWorld()).Empty_y = ((myWorld) getWorld()).Stored_Empty_y;
            }
    }
}
