import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color; // Colors
/**
 * Simple world.
 */
public class myWorld  extends World
{
    int Stored_Empty_x, Stored_Empty_y; // Used to store the location of the empty place.
    int Empty_x, Empty_y; // The empty place.

    String key; // Couldn't get the key from the piece.

    int x = 0, y = 0; // The offset in which to add the 4x4 tiles.
    
    long start_time, time; // Music has gone crazy for me.

    GreenfootImage base = new GreenfootImage("Background.png"); // The base image.
    boolean shuffle = false; // Should we shuffle the pieces?
    GreenfootSound music = new GreenfootSound("Loop.mp3"); // I like mp3 files more than midi...

    /**
     * Constructor for objects of class myWorld.
     */

    public myWorld()
    {    
        // Create a new world with 400x400 cells with a cell size of 1x1 pixels.
        super(400, 400, 1);
        
        start_time = System.currentTimeMillis();

        /**
         * Add the pieces.
         */
        populate_few();

        /**
         * Use a semi-transparent version of the completed image for comparison.
         */
        base.scale(400, 400);
        setBackground(base);
    }

    public void populate_few()
    {       
        /**
         * Add the pieces for the 4 piece puzzle and make sure we're not shuffling.
         */     
        shuffle = false;

        Stored_Empty_x = 300;
        Stored_Empty_y = 300;
        Empty_x = 300;
        Empty_y = 300;

        addObject(new SlidingPiece(1), 100, 100);
        addObject(new SlidingPiece(2), 300, 100);
        addObject(new SlidingPiece(3), 100, 300);
        y = 0;
        x = 0;
    }

    public void act()
    {     
        key = Greenfoot.getKey();
        /**
         * Play the soundfile on loop.
         */
        if(!music.isPlaying())
        {
            music.play();
        }
        
        time = System.currentTimeMillis();
        
        if((time - start_time) / 800 >= 43)
        {
            music.stop();
            start_time = time;
        }

        keys();
    }

    private void keys()
    {
        /**
         * To switch puzzles, press 0.
         */
        if(Greenfoot.isKeyDown("0"))
        {
            removeObjects(getObjects(SlidingPiece.class));
            if(y != 0)
            {
                populate_few();
            }
            else
            {
                populate_many();
            }
            Greenfoot.delay(8);
        }

        /**
         * Shuffle.
         */
        if(Greenfoot.isKeyDown("9") && shuffle == false)
        {
            shuffle = true;
            Greenfoot.delay(8);
        }

        /**
         * Stop shuffle.
         */
        if(Greenfoot.isKeyDown("9") && shuffle == true)
        {
            shuffle = false;
            Greenfoot.delay(8);
        }
    }

    public void populate_many()
    {
        /**
         * This adds all the pieces of the big puzzle.
         */
        Stored_Empty_x = 300;
        Stored_Empty_y = 300;
        Empty_x = 350;
        Empty_y = 350;

        /**
         * First column.
         */
        for(int i = 0; i < 16; i += 8)
        {
            addObject(new SlidingPiece(5+i), 50+x, 50+y);
            addObject(new SlidingPiece(6+i), 150+x, 50+y);
            addObject(new SlidingPiece(7+i), 50+x, 150+y);
            addObject(new SlidingPiece(8+i), 150+x, 150+y);
            x += 150;

            if(x == 150)
            {
                x = 0;
                y = 200;
            }
        }

        /**
         * Second column.
         */
        addObject(new SlidingPiece(9), 250, 50);
        addObject(new SlidingPiece(10), 350, 50);
        addObject(new SlidingPiece(11), 250, 150);
        addObject(new SlidingPiece(12), 350, 150);

        addObject(new SlidingPiece(17), 250, 250);
        addObject(new SlidingPiece(18), 350, 250);
        addObject(new SlidingPiece(19), 250, 350);
    }
}
